/*
 * Classname: LanguageGB
 * Version: 1.17
 * Date: 20.05.2006
 * Copyright: Copyright (c) 2006 Gunn Olaussen, Kirsti N. Torgersen. All Rights Reserved.
 * 
 * This software is the intellectual property of Gunn Olaussen and Kirsti N. Torgersen 
 * (henceforth called the developers). It cannot be exploited financially used for any 
 * purpose by others than the developers, except in accordance with the terms of the 
 * agreement between Kantega AS and the developers.
 */

package mymobilesite.controller;

/**
 * The LangugageGB class is an implementation of the Language class which initializes the
 * values by giving them English (GB) values.
 * 
 * @author Gunn Olaussen & Kirsti N. Torgersen
 */
public class LanguageGB extends Language {

    /**
     * The constructor gives all the variables a value in English (GB).
     */
    public LanguageGB() {
        super();
        label_applName = "MyMobileSite";
        label_idp = "Login service:";
        label_un = "Username:";
        label_pwd = "Password:";
        label_help = "Help:";
        label_language = "Supported languages:";
        label_providers = "Service providers:";
        label_services = "Available services:";
        label_error = "An error occurred";
        label_waiting = "Please wait ...";

        help = "Login:\nThe name of the log-in service is stated on the login screen and you " +
                "should ensure that this is your correct provider before sending your username " +
                "and password.\n\nLanguage:\nThe language can be changed by choosing Settings in " +
                "the main menu.\n\nApplication:\nAfter log-in the application will try to find the " +
                "providers offering services for your user. After selecting a provider, a list of " +
                "services is found and you can select one of these at a " + 
                "time to look at.";

        command_back = "Back";
        command_exit = "Exit";
        command_ok = "OK";
        command_help = "Help";
        command_save = "Save";
        command_settings = "Settings";
        command_tryagain = "Try again";

        error_messages[ERROR_IDPNAME_NOTFOUND] = "The name of the log-in service was not found";
        error_messages[ERROR_IDP_NOTFOUND] = " The log-in service was not found";
        error_messages[ERROR_IDP_NOTTRUSTED] = "The log-in service could not be trusted";
        error_messages[ERROR_IDP_LOSTCONTACT] = "The connection with the log-in service was terminated";
        error_messages[ERROR_IDP_FAULT] = "The log-in service returned a fault";
        error_messages[ERROR_IDP_TIMESTAMPDEVIATION] = "Wrong time settings on mobile or log-in service";
        error_messages[ERROR_DS_LOSTCONTACT] = "The connection with the provider directory was terminated";
        error_messages[ERROR_DS_NORESULTS] = "No providers found";
        error_messages[ERROR_DS_TIMESTAMPDEVIATION] = "Wrong time settings on mobile or provider directory";
        error_messages[ERROR_WSP_LOSTCONTACT] = "The connection with the service provider was terminated";
        error_messages[ERROR_WSP_NORESULTS] = "No services found";
        error_messages[ERROR_WSP_RECEIVEDFAULT] = "";
        error_messages[ERROR_WSP_TIMESTAMPDEVIATION] = "Wrong time settings on mobile or service provider";
        error_messages[ERROR_REPLAY_DETECTED] = "Message replay: Invalid message received";
        error_messages[ERROR_INVALID_MESSAGE] = "Received message with invalid format";
        error_messages[ERROR_AUTH_NOTACCEPTED] = "The server rejected the log-in";

        waiting_messages[WAITING_IDP_SESSION] = "Contacting log-in service";
        waiting_messages[WAITING_VERIFYING_PWD] = "Verifying password";
        waiting_messages[WAITING_FINDING_WSP] = "Finding providers";
        waiting_messages[WAITING_GETTING_SERVICES] = "Retrieving services";
    }
}
