/*
 * Classname: LanguageNB
 * Version: 1.16
 * Date: 20.05.2006
 * Copyright: Copyright (c) 2006 Gunn Olaussen, Kirsti N. Torgersen. All Rights Reserved.
 * 
 * This software is the intellectual property of Gunn Olaussen and Kirsti N. Torgersen 
 * (henceforth called the developers). It cannot be exploited financially used for any 
 * purpose by others than the developers, except in accordance with the terms of the 
 * agreement between Kantega AS and the developers.
 */

package mymobilesite.controller;

/**
 * The LanguageNB class is an implementation of the Language class which instantiates the
 * values by giving them Norwegian values.
 * 
 * @author Gunn Olaussen & Kirsti N. Torgersen
 */
public class LanguageNB extends Language {

    /**
     * The constructor gives all the variables a value in Norwegian.
     */
    public LanguageNB() {
        super();
        label_applName = "MinMobilside";
        label_idp = "Innloggingstjeneste";
        label_un = "Brukernavn:";
        label_pwd = "Passord";
        label_help = "Hjelp";
        label_language = "Tilgjengelige sprk:";
        label_providers = "Tjenestetilbydere:";
        label_services = "Tilgjengelige tjenester:";
        label_error = "Det skjedde en feil";
        label_waiting = "Vent litt ...";

        help = "Innlogging:\nNavnet p innloggingstjenesten str p innloggingsskjermen og du br " +
                "sjekke at dette er din riktige tjeneste fr du sender inn brukernavn og passord.\n\n" +
                "Sprk:\nSprket kan endres ved  velge Innstillinger i hovedmenyen.\n\nApplikasjon:\n" +
                "Etter innlogging vil applikasjonen prve  finne tilbydere som har tjenester for din " +
                "bruker. Etter  ha valgt en tilbyder hentes det en liste med tjenester og du kan velge " +
                "en om gangen av disse for  se p.";

        command_back = "Tilbake";
        command_exit = "Avslutt";
        command_ok = "OK";
        command_help = "Hjelp";
        command_save = "Lagre";
        command_settings = "Innstillinger";
        command_tryagain = "Prv igjen";

        error_messages[ERROR_IDPNAME_NOTFOUND] = "Fant ikke navnet p innloggingstjeneste";
        error_messages[ERROR_IDP_NOTFOUND] = "Fant ikke innloggingstjeneste";
        error_messages[ERROR_IDP_NOTTRUSTED] = "Kunne ikke stole p innloggingstjeneste";
        error_messages[ERROR_IDP_LOSTCONTACT] = "Koblingen til innloggingstjeneste ble avbrutt";
        error_messages[ERROR_IDP_FAULT] = "Innloggingstjenesten returnerte en feil";
        error_messages[ERROR_IDP_TIMESTAMPDEVIATION] = 
            "Feil klokkeinnstilling p mobil eller innloggingstjeneste";
        error_messages[ERROR_DS_LOSTCONTACT] = "Koblingen til tilbyderlisten ble avbrutt";
        error_messages[ERROR_DS_NORESULTS] = "Fant ingen tilbydere";
        error_messages[ERROR_DS_TIMESTAMPDEVIATION] = 
            "Feil klokkeinnstilling p mobil eller tilbyderlisten";
        error_messages[ERROR_WSP_LOSTCONTACT] = "Koblingen til tjenestetilbyderen ble avbrutt";
        error_messages[ERROR_WSP_NORESULTS] = "Fant ingen tjenester";
        error_messages[ERROR_WSP_RECEIVEDFAULT] = "";
        error_messages[ERROR_WSP_TIMESTAMPDEVIATION] = 
            "Feil klokkeinnstilling p mobil eller tjenestetilbyder";
        error_messages[ERROR_REPLAY_DETECTED] = "Ugyldig felt i mottatt melding";
        error_messages[ERROR_INVALID_MESSAGE] = "Mottok melding med ugyldig format";
        error_messages[ERROR_AUTH_NOTACCEPTED] = "Tjeneren avviste innloggingen";

        waiting_messages[WAITING_IDP_SESSION] = "Kontakter innloggingstjeneste";
        waiting_messages[WAITING_VERIFYING_PWD] = "Sjekker passord";
        waiting_messages[WAITING_FINDING_WSP] = "Sker etter tilbydere";
        waiting_messages[WAITING_GETTING_SERVICES] = "Henter tjenester";
    }
}
