/*
 * Classname: Service
 * Version: 1.2
 * Date: 20.05.2006
 * Copyright: Copyright (c) 2006 Gunn Olaussen, Kirsti N. Torgersen. All Rights Reserved.
 * 
 * This software is the intellectual property of Gunn Olaussen and Kirsti N. Torgersen 
 * (henceforth called the developers). It cannot be exploited financially used for any 
 * purpose by others than the developers, except in accordance with the terms of the 
 * agreement between Kantega AS and the developers.
 */

package mymobilesite.controller;

/**
 * The Service class is used to store the information and values for a retrieved service. It
 * holds the name of the service as well as multiple values.
 * 
 * @author Gunn Olaussen & Kirsti N. Torgersen
 */
public class Service {
    private String name;
    private String[][] value;

    /**
     * @param name String The name of the service.
     * @param value String[][] A matrix which contains label and value pairs.
     */
    public Service(String name, String[][] value) {
        this.name = name;
        this.value = value;
    }

    /**
     * @return String The name of the service.
     */
    public String getName() {
        return name;
    }

    /**
     * @return String[][] A matrix which contains label and value pairs.
     */
    public String[][] getValue() {
        return value;
    }
}
