/*
 * Classname: ServiceRequestException
 * Version: 1.2
 * Date: 20.05.2006
 * Copyright: Copyright (c) 2006 Gunn Olaussen, Kirsti N. Torgersen. All Rights Reserved.
 * 
 * This software is the intellectual property of Gunn Olaussen and Kirsti N. Torgersen 
 * (henceforth called the developers). It cannot be exploited financially used for any 
 * purpose by others than the developers, except in accordance with the terms of the 
 * agreement between Kantega AS and the developers.
 */

package loanfund;

/**
 * This class is used when we need an Exception that should result in a RegisterFault message
 * being sent instead of a ServiceResponse. The purpose is to store the error code which allows
 * us to find the correct error message to send back to the mobile application.
 * 
 * @author Gunn Olaussen & Kirsti N. Torgersen
 */
public class ServiceRequestException extends Exception {

    /**
     * The Constructor call the Exception constructor with the error code as the message.
     * 
     * @param errorCode String The error code of the exception that occured
     */
    public ServiceRequestException(String errorCode) {
        super(errorCode);
    }
}
